<?php  
/* 
ParticleTraffic - Traffic Monitoring
http://stats.particlebook.com

Copyright (c) 2009 Tony Trupp / InnerOptics LLC

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE. 
*/

//To help you to debug
error_reporting(E_ALL ^ E_NOTICE); 

//HERE'S WHAT YOU NEED TO DO TO INSTALL ParticleTraffic
//=========================================================

// 1) First, set all the required variables within the ParticleTraffic.config library. Include the trailing slash.

// 2) Then include the main library
require_once(realpath(dirname(__FILE__)).'/ParticleTraffic.config.php');

// 3) Install the required table (you comment this out after ParticleTraffic is working)
ParticleTrafficInstaller::run();


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />

<title>Welcome to ParticleTraffic</title>

<!-- script src="js/ParticleTraffic_tracker.js" type="text/javascript"></script -->

<link href="./css/ParticleTraffic.style.css" rel="stylesheet" type="text/css" /> 
<link href="./css/ParticleTraffic.structure.css" rel="stylesheet" type="text/css" /> 

<?php 
//THIS LINE IS ALL YOU NEED TO TRACK A HIT
//=========================================================
ParticleTrafficTracker::printTrackingJS( ParticleTraffic_SITE_ID_NUMBER );
?>

</head>

<body id="ParticleTrafficBody">

<div id="ParticleTrafficPage" class="ParticleTraffic">

<?php  if( !strlen(ParticleTraffic_DATABASE) || !strlen(ParticleTraffic_DB_USERNAME) ){ ?>
	<h1>Welcome to ParticleTraffic</h1>
	
	<p>
	To get ParticleTraffic working, open up the config file, located at:<br /> 
	<?php echo ParticleTraffic_PATH.'ParticleTraffic.config.php'?><br />
	and enter the required database connection information.
	</p>
	
<?php  }elseif( 1==2 ){ ?>

	<h1>ParticleTraffic Database Connection Failed</h1>

	<p>ParticleTraffic could not connect to the database with the information you provided.</p>
	<p>Please double check the info in <?php echo ParticleTraffic_PATH.'ParticleTraffic.config.php'?> and try again.</p>

<?php  }elseif( !ParticleTrafficInstaller::installCheck() ){ ?>

	<h1>ParticleTraffic Table not found.</h1>

	<p>There was a problem installing all the necessary tables.  Please try the installation again.</p>

<?php  }else{ ?>

	<h1>Your ParticleTraffic installation was successful!</h1>
	
	<p>If everything is working right this page view was just tracked.</p>
	
	<p>Try <a href="index.php">visiting your stats page</a></p>
	
	<p>This page was just provided as an example of how to track a hit.  You can safety remove it from your site.</p>

<?php  } ?>

</div>

</body>
</html>