<?php  

if(!defined('ParticleTraffic_PATH')) die;

class ParticleTrafficDisplay{

	public $siteIdNumber=0;
	
	//public static $db;

	public static $statsDisplayInstance;
	public static function loadAndDisplay($siteIdNumber=0,$noLoginRequired=0){
		$statsDisplay=new ParticleTrafficDisplay($siteIdNumber);
		/*
		if( !ParticalStatsAuthentication::isLoggedIn() && !$noLoginRequired ){ 
			if(!ParticalStatsAuthentication::login($_REQUEST['user'],$_REQUEST['pass']))
				return $statsDisplay->loginBox();
		}
		*/ 
		$statsDisplay->loadStatData();
		return $statsDisplay->displayStatsHTML();
	}

	public function __construct($siteIdNumber=0){
		$this->siteIdNumber=intval($siteIdNumber);
		$this->db = ParticleTrafficDB::get_instance(); 
	}	
	
	//for ignoring certain groups, domains, and IPs 
	public function getConfigTrackingSettings(){
		if(is_array($this->trackingSettings)) return $this->trackingSettings; 
		$this->trackingSettings = unserialize(Config::get('TONY_STATS_TRACKING_SETTINGS')); 
		if(!is_array($this->trackingSettings)) $this->trackingSettings=array();	
		return $this->trackingSettings;
	} 
	
	public function getExcludedUIDs(){
		if(is_array($this->excludedUIDs)) return $this->excludedUIDs; 
		$trackingSettings = $this->getConfigTrackingSettings();
		if (!is_array($trackingSettings['gIDs']) || !count($trackingSettings['gIDs'])) return array();  
		$sql='SELECT uID FROM UserGroups WHERE UserGroups.gID IN ('.join(',',$trackingSettings['gIDs']).')'; 
		$rows = $this->db->get_array($sql);
		$this->excludedUIDs=array();
		foreach($rows as $row)
			if(intval($row['uID'])) 
				$this->excludedUIDs[]=intval($row['uID']);
		return $this->excludedUIDs;
	}
	
	//to limit the number of results for each panel 
	public function getPanelSetting($key){
		if(is_array($this->panelSettings)) return intval($this->panelSettings[$key])?intval($this->panelSettings[$key]):15;
		$this->panelSettings = unserialize(Config::get('TONY_STATS_PANEL_SETTINGS')); 
		if(!is_array($this->panelSettings)) $this->panelSettings=array();	
		return intval($this->panelSettings[$key])?intval($this->panelSettings[$key]):15;
	}

	//for displaying the traffic analysis interface
	public function printHeaderFiles( $siteIdNumber=0 ){
		echo '<link href="'.ParticleTraffic_URL_DIR.'css/ParticleTraffic.structure.css" rel="stylesheet" type="text/css" />'."\n";
		ParticleTrafficDisplay::printDisplayJavascript($siteIdNumber);
	}
	
	public function printDisplayJavascript( $siteIdNumber=0 ){
		echo '<script src="'.ParticleTraffic_URL_DIR.'ParticleTraffic.services.php?mode=display_js&site='.intval($siteIdNumber).'" type="text/javascript"></script> '."\n";
	}
	
	public function loginBox(){
		ob_start(); 
		include(ParticleTraffic_PATH.'views/login_box.php');
		$html=ob_get_contents();
		ob_end_clean();
		return $html;
	} 


	public function loadStatData(){ 
	
		//up the max execution time if it's low, just incase stats haven't been accessed in a while 
		if( intval(ini_get('max_execution_time'))<=300 && !ini_get('safe_mode')  ) 
			set_time_limit( 300 ); 
			
		if( intval(str_replace(array('M','m'),'',ini_get('memory_limit')))<=64 && !ini_get('safe_mode')  )  
			ini_set('memory_limit', '64M'); 
	
		$this->purgeOldData();
	
		$this->browserData=$this->getBrowserStats();
		$this->platformData=$this->getPlatformStats();
		$this->screenData=$this->getResolutionStats();
		$this->flashData=$this->getFlashStats();
		$this->referrerData['top']=$this->getTopReferrers();
		$this->referrerData['recent']=$this->getRecentReferrers();
		$this->searchesData['top']=$this->getTopSearches();
		$this->searchesData['recent']=$this->getRecentSearches(); 
		$this->pagesData['top']=$this->getTopPages();
		$this->pagesData['recent']=$this->getRecentPages();		
		$this->getVisitData(); 
		$this->visitPaths=$this->getVisitPaths();
		//$this->generateGraphXML($this->visitData,'year'); 
		//$this->generateGraphXML($this->visitData,'day');
		//$this->generateGraphXML($this->visitData,'week'); 
		
		self::$statsDisplayInstance=$this;
	}
	
	public function displayStatsHTML(){
		ob_start(); 
		include(ParticleTraffic_PATH.'views/main_template.php');
		$html=ob_get_contents();
		ob_end_clean();
		return $html;
	}
	
	public function purgeOldData(){
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( $excludeDomainsSQL ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL.' '; 
		for($i=12;$i>1;$i-- ){ 
			$monthStart = mktime(0,0,0,date('n')-$i,1,date('Y'));
			$monthEnd = mktime(0,0,0,date('n')-$i+1,1,date('Y')); 
			$sql='SELECT tv.traffic_visit_id, count(th.traffic_visits_id) AS views FROM '.ParticleTrafficTracker::$hits_table.' AS th, '.ParticleTrafficTracker::$visits_table.' AS tv WHERE ';
			$sql.= ' tv.traffic_visit_id=th.traffic_visits_id AND tv.created>'.$monthStart.' AND tv.created< '.$monthEnd.' ' . $excludeDomainsSQL . ' GROUP BY tv.traffic_visit_id '; 
			$rows = $this->db->get_array($sql);
			$visits=0;
			$views=0;
			foreach( $rows as $row ){
				$visits++;
				$views+=intval($row['views']);
			} 
			if($visits){
				$where='datetime > '.$monthStart.' AND datetime < '.$monthEnd;
				$cachedMonthVOs=ParticleTrafficCachedMonth::retrieveList($where,1,'datetime DESC');
				$datetime=mktime(1,1,1,date('n')-$i,1,date('Y'));
				if(!count($cachedMonthVOs)){ 
					$monthVO = new ParticleTrafficCachedMonth();
				}else{
					$monthVO=$cachedMonthVOs[0];			
				}  
				if( $visits > $monthVO->get_visits() && $views > $monthVO->get_pageviews() ){  
					$monthVO->set_datetime( $datetime );
					$monthVO->set_visits( $visits );
					$monthVO->set_pageviews( $views );
					$monthVO->save();			  
				}
				
				//delete old hits 
				$sql='DELETE th.* FROM '.ParticleTrafficTracker::$hits_table.' as th, '.ParticleTrafficTracker::$visits_table.' as tv WHERE tv.traffic_visit_id=th.traffic_visits_id AND tv.created<'.$monthEnd; 
				$this->db->query($sql);
				
				//delete old visits 
				$sql='DELETE FROM '.ParticleTrafficTracker::$visits_table.' WHERE created<'.$monthEnd; 
				$this->db->query($sql);	
			}
		} 
	}	

	public function getVisitData($useCache=0){		
	
		//if this is used on the dashboard homepage, then we'll use the cache 
		if($useCache && !$_REQUEST['testing']){
			$lastCached=Config::get('TONY_STATS_LAST_CACHED');  //this is redundant, but easier for testing  
			$cache = Cache::get('tony_stats_cache', 'visits'); 
			if(count($cache) && $lastCached>(time()-(60*60*1))){
				$this->visitData=$cache; 
				return $this->visitData;
			}
		} 
	
		//get cached month data
		$sql='SELECT * FROM '.ParticleTrafficTracker::$cache_table.' '; 
		$cachedMonthResults=$this->db->get_array($sql);
		
		//get cached days data
		$sql='SELECT * FROM '.ParticleTrafficTracker::$cache_days_table.' '; 		
		$cachedDayResults=$this->db->get_array($sql);	 
		
		//get recent hits data 
		$results=$this->getRecentHits();
		
		//sort visit/hit data into hours, days, months, and years 
		$visitData=array( 'days'=>array(),'hours'=>array(),'months'=>array() );
		$visit_ids=array();
		$visitData['months']=array();

		$visitsDataYear=array();
		$visitsDataMonths=array();
		$visitsDataDays=array();
		$visitsDataHours=array();
		
		//this is memory intensive 
		foreach($results as $result){ 
			$hitTime=$result['created']; 
			$hourTimeKey=date('Y_m_z_G',$hitTime);
			$hourData=$visitsDataHours[$hourTimeKey];
			$visitsDataHours[$hourTimeKey]['pageviews']=$hourData['pageviews']+1;
			$dayTimeKey=date('Y_m_z',$hitTime);
			$dayData=$visitsDataDays[$dayTimeKey];
			$visitsDataDays[$dayTimeKey]['pageviews']=$dayData['pageviews']+1;
			//$visitData['weeks'][date('Y_W',$hitTime)]['pageviews']++;
			$monthTimeKey=date('Y_m',$hitTime);
			$monthData=$visitsDataMonths[$monthTimeKey];
			$visitsDataMonths[$monthTimeKey]['pageviews']=$monthData['pageviews']+1;
			$yearTimeKey=date('Y',$hitTime);
			$yearData=$visitsDataYear[$yearTimeKey];
			$visitsDataYear[$yearTimeKey]['pageviews']=$yearData['pageviews']+1;
			
			//is unique?
			if(isset($visit_ids[$result['traffic_visit_id']])) continue;
			$visitsDataHours[$hourTimeKey]['visits']=$hourData['visits']+1;
			$visitsDataDays[$dayTimeKey]['visits']=$dayData['visits']+1;
			//$visitData['weeks'][date('Y_W',$hitTime)]['visits']++;
			$visitsDataMonths[$monthTimeKey]['visits']=$monthData['visits']+1;
			$visitsDataYear[$yearTimeKey]['visits']=$yearData['visits']+1;
			$visit_ids[intval($result['traffic_visit_id'])]=$result['traffic_visit_id'];
		}
		
		$visitData['hours']=$visitsDataHours;
		$visitData['days']=$visitsDataDays; 
		$visitData['months']=$visitsDataMonths;
		$visitData['year']=$visitsDataYear;	

		//cache old day data   
		foreach($visitData['days'] as $dateKey=>$dayData){ 
			//skip today and yesterday, just to make sure we've got all the data 
			if( $dateKey >= date('Y_m_z',(time()-(3600*24*3))) ) continue;   
			$dateParts=explode('_',$dateKey); 
			$day=intval($dateParts[2]);	 //days are culmative since jan 1 
			$month=intval($dateParts[1]);
			$year=intval($dateParts[0]);	
			$where='datetime > '.mktime(0,0,0,1,$day+1,$year).' AND datetime < '.mktime(0,0,0,1,$day+2,$year).' AND book_id='.intval($this->siteIdNumber);
			$cachedDaysVOs=ParticleTrafficCachedDay::retrieveList($where,1,'datetime DESC'); 
			$datetime=mktime(12,1,1,1, $day+1, $year); 
			if(!count($cachedDaysVOs)){ 
				$dayVO = new ParticleTrafficCachedDay(); 
			}else{ 
				$dayVO=$cachedDaysVOs[0];			
			}
			if( intval($dayData['visits'])>$dayVO->get_visits() && intval($dayData['pageviews'])>$dayVO->get_pageviews() ){ 
				$dayVO->set_book_id( intval($this->siteIdNumber) );
				$dayVO->set_datetime( $datetime );
				$dayVO->set_visits( $dayData['visits'] );
				$dayVO->set_pageviews( $dayData['pageviews'] );
				$dayVO->save();
			}
		}
		 
		//add in prior retrieved cached days
		//if a day has been cached already, it ignores the hit data for that day  
		foreach($cachedDayResults as $result){ 
			$dayCacheDate=$result['datetime'];
			$dateKey=date('Y_m_z',$dayCacheDate); 
			$dateKeyMonth=date('Y_m',$dayCacheDate);
			//we'll only use cached days that are over a few days old, because we keep the recent hit and visit data anyway
			if( $dateKey >= date('Y_m_z',(time()-(3600*24*3))) ) continue; 
			//this month and last month should get it's stats from both cached days and visits/hits.  previous months use cached months
			$visitData['months'][$dateKeyMonth]['pageviews']=intval($visitData['months'][$dateKeyMonth]['pageviews'])+$result['pageviews']-$visitData['days'][$dateKey]['pageviews'];
			$visitData['months'][$dateKeyMonth]['visits']=intval($visitData['months'][$dateKeyMonth]['visits'])+$result['visits']-$visitData['days'][$dateKey]['visits'];
			$visitData['days'][$dateKey]['pageviews']=$result['pageviews'];
			$visitData['days'][$dateKey]['visits']=$result['visits']; 
		}   
		
		//cache older month data
		if(count($cachedDayResults)) foreach($visitData['months'] as $dateKey=>$monthData){   
			if( $dateKey==date('Y_m') || $dateKey==date('Y_m',(time()-(3600*24*40))) ) continue; 
			$dateParts=explode('_',$dateKey);
			$month=intval($dateParts[1]);
			$year=intval($dateParts[0]);
			
			$where='datetime > '.mktime(0,0,0,$month,0,$year).' AND datetime < '.mktime(0,0,0,$month+1,0,$year).' AND book_id='.intval($this->siteIdNumber);
			$cachedMonthVOs=ParticleTrafficCachedMonth::retrieveList($where,1,'datetime DESC');
			$datetime=mktime(1,1,1,$month,1,$year);
			if(!count($cachedMonthVOs)){ 
				$monthVO = new ParticleTrafficCachedMonth();
			}else{
				$monthVO=$cachedMonthVOs[0];			
			}  
			if( intval($monthData['visits'])>$monthVO->get_visits() && intval($monthData['pageviews'])>$monthVO->get_pageviews() ){
				$monthVO->set_book_id( intval($this->siteIdNumber) );
				$monthVO->set_datetime( $datetime );
				$monthVO->set_visits( $monthData['visits'] );
				$monthVO->set_pageviews( $monthData['pageviews'] );
				$monthVO->save();			  
			}
		}
		
		
		//cleanup old hits (over 9 days old) and cached days (over two months old)
		//the extra few days is padding to make sure they all get cached
			
		//keep at least 1000 recent visits, provided they're from the last 30 days  
		$todayTimeStamp=mktime(0,0,0,date('n'),date('j'),date('Y'));
		$minCutoffArray = $this->db->get_array('SELECT min(created) as minCutoff FROM '.ParticleTrafficTracker::$visits_table.' WHERE created > '.($todayTimeStamp-(3600*24*30)).' ORDER BY created DESC LIMIT 1000'); 
		//min cutoff is the timestamp of the 1000th visit 
		$minCutoff=intval($minCutoffArray[0]['minCutoff']);
		//make sure that we're not keeping more than one month of visit data 
		$maxCutoff= $todayTimeStamp-(3600*24*30);
		if( $minCutoff<$maxCutoff ) $minCutoff=$maxCutoff;
		$deleteAgeCutoff= $todayTimeStamp - (3600*24*9) ; 
		//only keep a week of hit/visit data, unless there haven't been that many visits recently, then keep up to a month 
		if( intval($minCutoff) && $minCutoff<$deleteAgeCutoff) $deleteAgeCutoff=$minCutoff; 
		
		if( !$_REQUEST['testing'] ){ 
			//delete old hits 
			$sql='DELETE th.* FROM '.ParticleTrafficTracker::$hits_table.' as th, '.ParticleTrafficTracker::$visits_table.' as tv WHERE tv.traffic_visit_id=th.traffic_visits_id AND tv.created<'.$deleteAgeCutoff; 
			$this->db->query($sql);
			
			//delete old visits
			$sql='DELETE FROM '.ParticleTrafficTracker::$visits_table.' WHERE created<'.$deleteAgeCutoff; 
			$this->db->query($sql);
			
			//delete cached days that are over 60 days old  
			$sql='DELETE FROM '.ParticleTrafficTracker::$cache_days_table.' WHERE datetime< '.(date('U')-(3600*24*60)); 
			$this->db->query($sql); 
		}
		
		
		//add in prior retrieved cached months
		//if a month is cached already, it'll overwrite all cached days and hits data, so no risk of double count 
		foreach($cachedMonthResults as $result){ 
			$monthCacheDate=$result['datetime'];
			$dateKey=date('Y_m',$monthCacheDate);
			//but only use the cached months if they're older than an entire month 
			if( $dateKey==date('Y_m') || $dateKey==date('Y_m',(time()-(3600*24*30))) ) continue;
			//legacy bug fix. data swapped in cache 
			if($result['pageviews']<$result['visits']){
				$tmpVisits=$result['visits'];
				$result['visits']=$result['pageviews']; 
				$result['pageviews']=$tmpVisits; 
			}
			$visitData['months'][$dateKey]['pageviews']=(intval($result['pageviews'])>intval($visitData['months'][$dateKey]['pageviews']))?intval($result['pageviews']):intval($visitData['months'][$dateKey]['pageviews']);
			$visitData['months'][$dateKey]['visits']=(intval($result['visits'])>intval($visitData['months'][$dateKey]['visits']))?intval($result['visits']):intval($visitData['months'][$dateKey]['visits']); 
		}	
		
		Config::save('TONY_STATS_LAST_CACHED', time() ); 

		Cache::set('tony_stats_cache', 'visits', $visitData, (time()+(3600*24)), true);
		
		$this->visitData=$visitData; 
		return $visitData; 
	}


	public static function cleanBrowserName($name=''){
		return ucwords( str_replace( array('msie'), array('Internet Explorer'),$name));
	}

	public function getBrowserStats(){
		$sql='SELECT browser, browser_version, count(*) as count FROM '.ParticleTrafficTracker::$visits_table.'  ';
		//if(intval($this->siteIdNumber)) $sql.=' WHERE book_id='.intval($this->siteIdNumber).' ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( $excludeDomainsSQL ) $excludeDomainsSQL=' WHERE '.$excludeDomainsSQL; 
		$sql.= $excludeDomainsSQL.' GROUP BY browser, browser_version ORDER BY created desc LIMIT 1000'; 
		$results=$this->db->get_array($sql);
		$familyData=array();
		$totalCount=0; 
		foreach($results as $result){
			if($result['browser']=='unrecognized') continue; 
			$totalCount=$totalCount+intval($result['count']);
		}
		if(!$totalCount) return array();
		foreach($results as $result){
			if($result['browser']=='unrecognized') continue; 
			$browser=$result['browser'];
			$familyData[$browser]['browser']=$browser;
			$familyData[$browser]['count'] = intval($familyData[$browser]['count'])+intval($result['count']);
			$percent = (intval($familyData[$browser]['count']) / $totalCount * 100);
			$familyData[$browser]['usage'] = $percent;
			$version=intval($result['browser_version']);
			if($version>0){
				if(!$familyData[$browser]['validVersionsCount']) $familyData[$browser]['validVersionsCount']=0;
				$familyData[$browser]['validVersionsCount']=intval($familyData[$browser]['validVersionsCount'])+intval($result['count']);
				$familyData[$browser]['versions'][$version]['version']=$version;
				$familyData[$browser]['versions'][$version]['count']=intval($familyData[$browser]['versions'][$version]['count'])+intval($result['count']);
				//$percent = floor(intval($familyData[$browser]['versions'][$version]['count']) / intval($familyData[$browser]['validVersionsCount']) * 100);
				//$familyData[$browser]['versions'][$version]['usage'] = $percent;
			}
		}  
		foreach($familyData as $browser=>$data){
			$vc=$data['validVersionsCount'];
			if($data['versions']) foreach($data['versions'] as $versionNumber=>$versionData){
				$percent = (intval($versionData['count']) / intval($data['validVersionsCount']) * 100);
				$familyData[$data['browser']]['versions'][$versionData['version']]['usage'] = $percent;
			}
		}
		usort($familyData, 'sortByTrafficUsage'); 
		$familyData=array_reverse($familyData);
		$familyData=array_slice($familyData,0,15);		
		return $familyData;
	}
	
	public function getPlatformStats(){
		$sql='SELECT platform, count(*) as count FROM '.ParticleTrafficTracker::$visits_table.'  ';
		//if(intval($this->siteIdNumber)) $sql.=' WHERE book_id='.intval($this->siteIdNumber).' '; 
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' WHERE '.$excludeDomainsSQL; 
		$sql.= $excludeDomainsSQL.' GROUP BY platform ORDER BY created desc LIMIT 1000'; 
		$results=$this->db->get_array($sql);
		$familyData=array();
		$totalCount=0; 
		foreach($results as $result){
			if($result['platform']=='unrecognized') continue; 
			$totalCount=$totalCount+intval($result['count']);
		}
		if(!$totalCount) return array();
		foreach($results as $result){
			if($result['platform']=='unrecognized') continue; 
			$id=$result['platform'];
			$familyData[$id]['count'] = intval($familyData[$id]['count'])+intval($result['count']);
			$percent = floor(intval($familyData[$id]['count']) / $totalCount * 100);
			$familyData[$id]['usage'] = $percent;
			$familyData[$id]['platform'] = $result['platform'];
		}
		usort($familyData, 'sortByTrafficUsage'); 
		$familyData=array_reverse($familyData);
		$familyData=array_slice($familyData,0,15);		
		return $familyData;
	}
	
	public function getFlashStats(){
		$sql='SELECT flash_version, count(*) as count FROM '.ParticleTrafficTracker::$visits_table.' WHERE ';
		//if(intval($this->siteIdNumber)) $sql.=' book_id='.intval($this->siteIdNumber).' AND ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL; 
		$sql.=' resolution!="" '.$excludeDomainsSQL.' GROUP BY flash_version ORDER BY created desc LIMIT 1000'; 
		$results=$this->db->get_array($sql);
		$familyData=array();
		$totalCount=0; 
		foreach($results as $result){
			$totalCount=$totalCount+intval($result['count']);
		}
		if(!$totalCount) return array();
		foreach($results as $result){ 
			$id='version'.$result['flash_version'].'.0';
			$familyData[$id]['version']=$result['flash_version'].'.0';
			$familyData[$id]['count'] = intval($familyData[$id]['count'])+intval($result['count']);
			$percent = floor(intval($familyData[$id]['count']) / $totalCount * 100);
			$familyData[$id]['usage'] = $percent;
		}   	
		usort($familyData, 'sortByTrafficUsage'); 
		$familyData=array_reverse($familyData);
		$familyData=array_slice($familyData,0,15);		
		return $familyData;
	}	
	
	public function getResolutionStats(){
		$sql='SELECT resolution, count(*) as count FROM '.ParticleTrafficTracker::$visits_table.' ';
		//if(intval($this->siteIdNumber)) $sql.=' WHERE book_id='.intval($this->siteIdNumber).' ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' WHERE '.$excludeDomainsSQL; 
		$sql.= $excludeDomainsSQL.' GROUP BY resolution ORDER BY resolution LIMIT 1000'; 
		$results=$this->db->get_array($sql);
		$familyData=array();
		$totalCount=0; 
		foreach($results as $result){
			if($result['resolution']=='') continue;
			$totalCount=$totalCount+intval($result['count']);
		}
		if(!$totalCount) return array();
		foreach($results as $result){
			if($result['resolution']=='') continue; 
			$dimensions=explode('x',$result['resolution']);
			$x=intval(trim($dimensions[0]));
			$y=intval(trim($dimensions[1]));
			
			//round to standard sizes - heights
			//maybe just round height to nearest 50?
			if($y>2250 && $y<=2300) $y=2300;
			elseif($y>1150 && $y<=1200) $y=1200;
			elseif($y>1050 && $y<=1080) $y=1080; 
			elseif($y>1010 && $y<=1050) $y=1050;
			elseif($y>864 && $y<=900) $y=900;			
			elseif($y>824 && $y<=864) $y=864;
			elseif($y>768 && $y<=800) $y=800;
			elseif($y>740 && $y<=768) $y=768;
			elseif($y>680 && $y<=720) $y=720;
			elseif($y>600 && $y<=680) $y=650;
			//elseif($y>600 && $y<=610) $y=610; 
			elseif($y>560 && $y<=600) $y=600;
			elseif($y>440 && $y<=480) $y=480;
			
			//widths
			if($x>2000 && $x<=2048) $x=2048; 
			elseif($x>1880 && $x<=1920) $x=1920;
			elseif($x>1640 && $x<=1680) $x=1680;
			elseif($x>1560 && $x<=1600) $x=1600;
			elseif($x>1400 && $x<=1440) $x=1440;
			elseif($x>1280 && $x<=1300) $x=1300;
			elseif($x>1230 && $x<=1280) $x=1280;
			elseif($x>1112 && $x<=1152) $x=1152;
			elseif($x>980 && $x<=1024) $x=1024;
			elseif($y>810 && $y<=854) $y=854;
			elseif($x>760 && $x<=800) $x=800; 
			elseif($y>680 && $y<=720) $y=720; 
			elseif($x>600 && $x<=640) $x=640;
			
			$y=round($y/10)*10;
			$x=round($x/10)*10; 
					
			$result['resolution']=$x.' x '.$y;
			$familyData[$result['resolution']]['resolution']=$result['resolution'];
			$familyData[$result['resolution']]['sortName'] = intval(substr($result['resolution'],0,strpos(strtolower($result['resolution']),'x')-1));
			$familyData[$result['resolution']]['count'] = intval($familyData[$result['resolution']]['count'])+intval($result['count']);
			$percent = floor(intval($familyData[$result['resolution']]['count']) / $totalCount * 100);
			$familyData[$result['resolution']]['usage'] = $percent;
		}   
		usort($familyData, 'sortByTrafficUsage'); 
		$familyData=array_reverse($familyData);
		$familyData=array_slice($familyData,0,$this->getPanelSetting('resolutionsLimit'));
		return $familyData;
	} 
	
	static public $oldestVisitTime=0;
	static public function getOldestVisitTime(){
		if(self::$oldestVisitTime) return self::$oldestVisitTime; 
		$sql='SELECT min(created) FROM  '.ParticleTrafficTracker::$visits_table.' WHERE created!=0 '; 
		$db = ParticleTrafficDB::get_instance(); 
		$time=$db->get_field($sql); 
		self::$oldestVisitTime=intval($time);
		return self::$oldestVisitTime;
	}
	
	public function getExcludeDomainsSQL($tv_table='tv'){
		$settings = $this->getConfigTrackingSettings();
		if( !is_array($settings['ignoredDomains']) || !count($settings['ignoredDomains']) )
			return '';
			
		if( strlen($tv_table) && !strstr($tv_table,'.') ) 
			$tv_table=$tv_table.'.';
			
		//separate IPs and Domains 
		$ips=array();
		$domains=array();
		foreach($settings['ignoredDomains'] as $row){
			if( preg_replace("/[^0-9\.\-]/i",'', $row)==$row ) 
				 $ips[]=$row; 
			else $domains[]=$row;
		}
			
		if(count($ips)) $ipsSQL = ' '.$tv_table.'ip NOT IN ("'.join('","',$ips).'") ';
		if(count($domains)) $hostsSQL = ' '.$tv_table.'host_name NOT IN ("'.join('","',$domains).'") ';
		
		$sql = ($ipsSQL && $hostsSQL) ? $hostsSQL.' AND '.$ipsSQL : $hostsSQL.' '.$ipsSQL;
		
		$excludedUIDs = $this->getExcludedUIDs();
		if( count($excludedUIDs) ) $sql.=' AND '.$tv_table.'users_id NOT IN ('.join(',',$excludedUIDs).') '; 
		
		return trim($sql);
	}
	
	public function getVisitPaths( $visit_id=false, $limitVisits=false ){  
		return $this->searchVisitPaths( array('visit_id'=>$visit_id,'limit_visits'=>$limitVisits) );
	}	
	
	public function searchVisitPaths( $params=array() ){
		
		$sqlVals=array();
		
		$page=(intval($params['page'])) ? intval($params['page']) : 1; 
		
		$limitVisits=$params['limit_visits']; 
		
		$visitsCount = ( intval($limitVisits)>0 ) ? intval($limitVisits) : $this->getPanelSetting('visitsLimit'); 
		if( intval($visitsCount)<=0 ) $visitsCount=20; 
		
		$sqlCount = 'SELECT count(*) '; 
		$sqlSelect = 'SELECT tv.* '; 
		
		$sql=' FROM '.ParticleTrafficTracker::$visits_table.' AS tv WHERE 1=1 '; 
		
		if(intval($params['visit_id'])) $sql.=' AND tv.traffic_visit_id='.intval($params['visit_id']).'  '; 
		
		if( intval($params['start_date']) ){
			$sql.=' AND tv.created>?  '; 
			$sqlVals[]=intval($params['start_date']);
		} 
		
		if( intval($params['end_date']) ){
			$sql.=' AND tv.created < ?  '; 
			$sqlVals[]=intval($params['end_date']);
		} 
		
		if( strlen($params['ip']) ){
			$sql.=' AND tv.ip=?  '; 
			$sqlVals[]=$params['ip'];
		} 
		
		if( isset($params['uID']) && intval($params['uID']) >= -1 ) $sql.=' AND tv.users_id='.intval($params['uID']).'  '; 
		
		$excludeDomainsSQL = $this->getExcludeDomainsSQL();
		if( strlen($excludeDomainsSQL) ) $sql.=' AND '.$excludeDomainsSQL;  
		
		$this->visitsSearchResultsCount= $this->db->get_field( $sqlCount.$sql , $sqlVals);
		
		$jsFunc='UserVisitsPanel.getPg';
		$c = Page::getCurrentPage();
		$paging_url = View::url( $c->getCollectionPath(),'panel_service','user_visits','search');
		if( !strstr($paging_url,'?') ) $paging_url=$paging_url.'?';
		$paging_url.='ip='.urlencode($params['ip']).'&user_name='.urlencode($params['user_name']); 
		$this->visitsPagination = Loader::helper('pagination');	 
		$this->visitsPagination->queryStringPagingVariable='visits_pg';	  
		$this->visitsPagination->init( $page, $this->visitsSearchResultsCount, $paging_url, $visitsCount, $jsFunc );   
		//$this->visitsPagination->result_offset
		
		if( intval($visitsCount) ) $visitsCountSQL = ' LIMIT ' . $this->visitsPagination->getLIMIT(); 
		$sql.=' ORDER BY created desc ' . $visitsCountSQL;		
		
		$visits = $this->db->get_array( $sqlSelect.$sql , $sqlVals); 
		
		return $this->loadVisitPathHits( $visits );
	}	
	
	public function loadVisitPathHits($visits){
		$visitData=array();
		foreach($visits as $visit){
			$sql='SELECT th.* FROM '.ParticleTrafficTracker::$hits_table.' AS th WHERE th.traffic_visits_id='.intval($visit['traffic_visit_id']).' ORDER BY created DESC LIMIT 500';
			$visit['hitData']=$this->db->get_array($sql);
			if(count($visit['hitData'])) $visitData[]=$visit;
		}
		return $visitData;
	}
	
	public function getCountryDataFromIP($ip){ 
		if(substr($ip,0,8)=='127.0.0.' || substr($ip,0,8)=='192.168.0.') return array();
		if(!$this->db) $this->db = ParticleTrafficDB::get_instance(); 
		$ip = preg_replace("/[^0-9\*.,]/i",'', $ip); 
		$sql = 'SELECT c.* FROM ip2nationCountries c, ip2nation i WHERE i.ip < INET_ATON("'.$ip.'") AND c.code = i.country ORDER BY i.ip DESC'; 
		$data= $this->db->get_row($sql);  
		return $data; 
	}
	
	static private $cachedUsers=array();
	static function getCachedUser($uID=0){
		$uID=intval($uID);
		if(self::$cachedUsers[$uID]){
			return self::$cachedUsers[$uID];
		}else{
			self::$cachedUsers[$uID]=User::getByUserID($uID);
			return self::$cachedUsers[$uID];
		}
	}
	
	static private $cachedUserInfos=array();
	static function getCachedUserInfo($uID=0){
		$uID=intval($uID);
		if(self::$cachedUserInfos[$uID]){
			return self::$cachedUserInfos[$uID];
		}else{
			self::$cachedUserInfos[$uID]=UserInfo::getByID($uID);
			return self::$cachedUserInfos[$uID];
		}
	}
	
	
	public function getTopCountries(){
		$sql='SELECT tv.*, count(traffic_hits_id) as hitCount FROM '.ParticleTrafficTracker::$visits_table.' AS tv, '.ParticleTrafficTracker::$hits_table.' AS th WHERE ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL();
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL; 
		$sql .= '  tv.traffic_visit_id=th.traffic_visits_id '.$excludeDomainsSQL.' GROUP BY th.traffic_visits_id ORDER BY created desc LIMIT 5000';
		$visits=$this->db->get_array($sql);
		$countriesData=array(); 
		$countriesVisits=array();
		$countriesRecentVisits=array();
		$totalVisits=0;
		foreach($visits as $visit){ 
			$ip=$visit['ip']; 
			if($ip=='127.0.0.1') continue;
			$totalVisits++;
			$countryData = ParticleTrafficDisplay::getCountryDataFromIP($ip); 
			$countryCode = $countryData['code']; 
			$countriesRecentVisits[$countryCode][]=$visit;
			$countriesVisits[$countryCode]= intval($countriesVisits[$countryCode])+1;
			if( !array_key_exists($countryCode,$countriesData) ) 
				$countriesData[$countryCode]= $countryData; 
		} 
		return array('visits'=>$countriesVisits,'data'=>$countriesData,'totalVisits'=>$totalVisits,'recentVisits'=>$countriesRecentVisits);
	}
	
	
	
	//top sites
	public function getTopBooks(){
		//$sql='SELECT tv.book_id, count(*) as count FROM traffic_visits AS tv  '; 
		//$sql.=' GROUP BY tv.book_id ORDER BY count desc LIMIT 20'; 
		$sql='SELECT tv.book_id, count(tv.traffic_visit_id) as count, (SELECT count(th2.traffic_hits_id) FROM '.ParticleTrafficTracker::$hits_table.' AS th2, '.ParticleTrafficTracker::$visits_table.' AS tv2 WHERE tv2.traffic_visit_id=th2.traffic_visits_id AND tv2.book_id=tv.book_id) as h_count '; 
		$sql.=' FROM traffic_visits AS tv GROUP BY tv.book_id ORDER BY count desc LIMIT 30'; 		
		$results=$this->db->get_array($sql);
		return $results;
	}	
	
	public function getTopPages(){
		$sql='SELECT th.page_url, th.page_url_short, th.page_title, tv.book_id, count(*) as count FROM '.ParticleTrafficTracker::$hits_table.' AS th, '.ParticleTrafficTracker::$visits_table.' AS tv WHERE ';
		if(intval($this->siteIdNumber)) $sql.=' tv.book_id='.intval($this->siteIdNumber).' AND ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL();
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL; 
		$sql.=' th.page_url_short!="" AND tv.traffic_visit_id=th.traffic_visits_id '.$excludeDomainsSQL.'  GROUP BY th.page_url_short, th.page_title ORDER BY count desc LIMIT '.$this->getPanelSetting('pagesLimit'); 
		$results=$this->db->get_array($sql);
		return $results;
	}
	
	public function getRecentPages(){
		$sql='SELECT th.page_url, page_url_short, page_title, th.created AS hitCreated, tv.book_id, tv.* FROM '.ParticleTrafficTracker::$hits_table.' AS th, '.ParticleTrafficTracker::$visits_table.' AS tv WHERE ';
		if(intval($this->siteIdNumber)) $sql.=' tv.book_id='.intval($this->siteIdNumber).' AND ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL();
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL; 
		$sql.=' th.page_url_short!="" AND tv.traffic_visit_id=th.traffic_visits_id '.$excludeDomainsSQL.'  ORDER BY th.created desc LIMIT '.$this->getPanelSetting('pagesLimit'); 
		$results=$this->db->get_array($sql);
		return $results;
	}	
	
	public function getTopReferrers(){
		$sql='SELECT referrer_url, count(*) as count FROM '.ParticleTrafficTracker::$visits_table.' WHERE ';
		if(intval($this->siteIdNumber)) $sql.=' book_id='.intval($this->siteIdNumber).' AND ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL; 
		$sql.=' referrer_url!="" '.$excludeDomainsSQL.' GROUP BY referrer_url ORDER BY count desc LIMIT '.$this->getPanelSetting('referrersLimit'); 
		$results=$this->db->get_array($sql);
		return $results;
	}
	
	public function getRecentReferrers(){
		$sql='SELECT referrer_url, created FROM '.ParticleTrafficTracker::$visits_table.' WHERE ';
		if(intval($this->siteIdNumber)) $sql.=' book_id='.intval($this->siteIdNumber).' AND ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL; 
		$sql.=' referrer_url!="" '.$excludeDomainsSQL.' ORDER BY created desc LIMIT '.$this->getPanelSetting('referrersLimit'); 
		$results=$this->db->get_array($sql);
		return $results;
	}	
	
	public function getTopSearches(){
		$sql='SELECT search_terms, count(*) as count FROM '.ParticleTrafficTracker::$visits_table.' WHERE ';
		if(intval($this->siteIdNumber)) $sql.=' book_id='.intval($this->siteIdNumber).' AND ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL; 
		$sql.=' search_terms!="" '.$excludeDomainsSQL.' GROUP BY search_terms ORDER BY count desc LIMIT '.$this->getPanelSetting('searchesLimit'); 
		$results=$this->db->get_array($sql);
		return $results;
	}
	
	public function getRecentSearches(){
		$sql='SELECT search_terms, created FROM '.ParticleTrafficTracker::$visits_table.' WHERE ';
		if(intval($this->siteIdNumber)) $sql.=' book_id='.intval($this->siteIdNumber).' AND ';
		$excludeDomainsSQL = $this->getExcludeDomainsSQL('');
		if( strlen($excludeDomainsSQL) ) $excludeDomainsSQL=' AND '.$excludeDomainsSQL; 
		$sql.=' search_terms!="" '.$excludeDomainsSQL.' ORDER BY created desc LIMIT '.$this->getPanelSetting('searchesLimit'); 
		$results=$this->db->get_array($sql);
		return $results;
	}
	
	public function getRecentHits(){ 
		$excludeDomainsSQL = $this->getExcludeDomainsSQL();  
		if($excludeDomainsSQL) $excludeDomainsSQL.=' AND '; 
		$sql='SELECT tv.traffic_visit_id, th.page_url, th.page_title, th.created FROM '.ParticleTrafficTracker::$hits_table.' AS th, '.ParticleTrafficTracker::$visits_table.' AS tv WHERE ';
		$sql.= $excludeDomainsSQL . ' tv.traffic_visit_id=th.traffic_visits_id ORDER BY th.created desc'; 
		return $this->db->get_array($sql); 		
	}
	
	
	public function getChartImg($timeframe='day',$small=0){
		
		//chart type & size 
		$chartImg = "http://chart.apis.google.com/chart?cht=lc";
					
		$chartImg .= ($small)?'&chs=350x270':"&chs=550x300";
					
		//data set labels, data set position, & dataset colors, & data point style
		$chartImg .= "&chdl=Views|Visits&chdlp=b&chco=5377A9,999999&chm=o,5377A9,0,-1,8|o,999999,1,-1,8";
		
		//line thickness, axis labels, margins, background/grid lines, 
		$chartImg .= "&chls=4|3&chxt=x,y&chma=20,20,20,30|90,40&chf=bg,s,ffffff|c,lg,75,ffffff,0,f6f6f6,0.75&"; 
		
		$visits=array();
		$views=array();
		$xLabels=array();
		$maxPgViews=10;
		$visitData = $this->visitData;
		
		switch ($timeframe){
			case 'day':  
				for($i=24;$i>=0;$i--){  
					//if(intval(date('g',time()-($i*3600)))==12)
						$amPm=date('a',time()-($i*3600));
					//else $amPm=' '; 
					
					if($i%2==0) $xLabels[]= date('g',time()-($i*3600)).$amPm; 
					else $xml.= $xLabels[]= ' '; 
					
				}  
				for($i=24;$i>=0;$i--){ 
					$pv=intval( $visitData['hours'][date('Y_m_z_G',time()-($i*3600))]['pageviews'] ); 
					$views[]=$pv;
					if($pv>$maxPgViews) $maxPgViews=$pv; 
				}  
				for($i=24;$i>=0;$i--){ 		
					$pv=intval( $visitData['hours'][date('Y_m_z_G',time()-($i*3600))]['visits'] ); 
					$visits[]=$pv;
				} 	 
				break; 
			case 'year':  
				for($i=12;$i>=0;$i--){ 
					$time=mktime(1,1,1,date('n')-$i,1,date('Y')); 
					$xLabels[]= date('M',$time); 				
				}  
				for($i=12;$i>=0;$i--){			
					$time=mktime(1,1,1,date('n')-$i,1,date('Y'));		
					$pv=intval( $visitData['months'][date('Y_m',$time)]['pageviews'] );
					$views[]=$pv;
					if($pv>$maxPgViews) $maxPgViews=$pv; 
				}  
				for($i=12;$i>=0;$i--){			
					$time=mktime(1,1,1,date('n')-$i,1,date('Y'));	
					$pv=intval( $visitData['months'][date('Y_m',$time)]['visits'] );	
					$visits[]=$pv;
				} 			
				break;		
			case 'week':
			default: 
				for($i=7;$i>=0;$i--){  
					$xLabels[]= date('D',time()-($i*3600*24)); 	
				}  
				for($i=7;$i>=0;$i--){				
					$pv=intval( $visitData['days'][date('Y_m_z',time()-($i*3600*24))]['pageviews'] );	
					$views[]=$pv;
					if($pv>$maxPgViews) $maxPgViews=$pv;  
				}  
				for($i=7;$i>=0;$i--){					
					$pv=intval( $visitData['days'][date('Y_m_z',time()-($i*3600*24))]['visits'] );	
					$visits[]=$pv;
				} 			
				break;
		} 	
		
		$topLimit = ceil($maxPgViews*1.04);
		//$topLimit = ($topLimit%2==0) ? $topLimit : $topLimit+1;
		$smallestUnit=($topLimit>500)?100:10;
		$topLimit = ($topLimit%$smallestUnit==0) ? $topLimit : $topLimit+$smallestUnit-($topLimit%$smallestUnit);
		
		$percViews=array();
		foreach($views as $view) $percViews[]=($view/$topLimit)*100; 
		$percVisits=array();
		foreach($visits as $visit) $percVisits[]=($visit/$topLimit)*100; 		
		
		$dataStr = join(',',$percViews)."|".join(',',$percVisits)."&chxl=0:|".join('|',$xLabels)."&chg=25,10,1,5&chxr=1,0,".$topLimit;
		
		$chartImg .= '&chd=t:'.$dataStr;
		
		$yAxisLabels=array();
		$numberOfHorzLines=10;
		for($i=0;$i<$numberOfHorzLines;$i++){ 
			$yAxisLabels[]=ceil($topLimit/$numberOfHorzLines*($i+1));
		} 
		
		$chartImg .= '&chxp=1,'.join(',',$yAxisLabels);
			
		return $chartImg;
	}
	
	
	// XML Chart Data	
	//**************************************************************************************************************************
	
	public function getGraphXMLPath($timeframe='week'){
		
		return false; 
		
		//get path 
		$path=ParticleTraffic_CACHE_DIR; 
		
		if( !is_writable($path) )
			throw new Exception("The ParticleTraffic cache directory is not writable.  Make sure this folder has the correct permissions for writing and reading:\n".$path);
		if( !is_readable($path) )
			throw new Exception("The ParticleTraffic cache directory is not read.  Make sure this folder has the correct permissions for writing and reading:\n".$path);
		
		if($timeframe=='year') $file_name = $path.'stats_'.intval($this->siteIdNumber).'_year.xml';	
		elseif($timeframe=='day') $file_name = $path.'stats_'.intval($this->siteIdNumber).'_day.xml';
		elseif($timeframe=='month') $file_name = $path.'stats_'.intval($this->siteIdNumber).'_month.xml';	
		else $file_name = $path.'stats_'.intval($this->siteIdNumber).'_week.xml';	
		return $file_name;
	}
	
	public function generateGraphXML($visitData,$timeframe='week'){ 
		
		return false;  
	
		$xml= "<chart> \r\n";
		$xml.= "\t <chart_type>Line</chart_type> \r\n";
		// $xml.= "\t <tooltip color='FFFFFF' alpha='75' size='11' background_color='8888ff' background_alpha='90' shadow='low' /> \r\n";
		$xml.= "\t <chart_border top_thickness='1' bottom_thickness='1' left_thickness='1' right_thickness='1' /> \r\n";
		//<chart_grid_h alpha='10' thickness='1' type='solid' />
		$xml.= "\t <chart_grid_v alpha='10' thickness='1' type='solid' /> \r\n";
		$xml.= "\t <series_color> \r\n";
		$xml.= "\t\t <color>".str_replace('#','',ParticleTraffic_GRAPH_PAGE_VIEWS_COLOR)."</color> \r\n";
		$xml.= "\t\t <color>".str_replace('#','',ParticleTraffic_GRAPH_VISITS_COLOR)."</color> \r\n";
		$xml.= "\t </series_color> \r\n";
		$xml.= "\t <chart_rect x='30' y='40' width='350' height='190' />";
		$xml.= "\t <legend  x='50' y='10' width='350' height='30' />"; 
		$xml.= "\t <chart_data> \r\n"; 
		
		switch ($timeframe){
			case 'day': 
				$xml.= "\t\t <row> \r\n";
				$xml.= "\t\t\t <null/> \r\n"; 
				for($i=24;$i>=0;$i--){  
					if(intval(date('g',time()-($i*3600)))==12)
						$amPm=date('a',time()-($i*3600));
					else $amPm='';
					if($i%2==0) $xml.= "\t\t\t <string>".date('g',time()-($i*3600)).$amPm."</string> \r\n";
					else $xml.= "\t\t\t <string> </string> \r\n"; 
				}
				$xml.= "\t\t </row> \r\n"; 
				$xml.= "\t\t <row> \r\n"; 
				$xml.= "\t\t\t <string>Page Views</string> \r\n"; 
				for($i=24;$i>=0;$i--){ 
					$pv=intval( $visitData['hours'][date('Y_m_z_G',time()-($i*3600))]['pageviews'] );
					$xml.= "\t\t\t <number tooltip='".$pv." page views'>".$pv."</number> \r\n";  
				}
				$xml.= "\t\t </row> \r\n"; 	
				$xml.= "\t\t <row> \r\n"; 
				$xml.= "\t\t\t <string>Visits</string> \r\n"; 
				for($i=24;$i>=0;$i--){ 		
					$pv=intval( $visitData['hours'][date('Y_m_z_G',time()-($i*3600))]['visits'] );
					$xml.= "\t\t\t <number tooltip='".$pv." visits'>".$pv."</number> \r\n";  
				}
				$xml.= "\t\t </row> \r\n";				
				break;
			/*
			case 'month': 
				$xml.= "\t\t <row> \r\n";
				$xml.= "\t\t\t <null/> \r\n"; 
				for($i=24;$i>=0;$i--){  
					if($i%2==0) $xml.= "\t\t\t <string>".date('g',time()-($i*3600))."</string> \r\n";
					else $xml.= "\t\t\t <string> </string> \r\n"; 
				}
				$xml.= "\t\t </row> \r\n"; 
				$xml.= "\t\t <row> \r\n"; 
				$xml.= "\t\t\t <string>Page Views</string> \r\n"; 
				for($i=24;$i>=0;$i--){ 
					$pv=intval( $visitData['hours'][date('Y_m_z_G',time()-($i*3600))]['pageviews'] );
					$xml.= "\t\t\t <number tooltip='".$pv." page views'>".$pv."</number> \r\n";  
				}
				$xml.= "\t\t </row> \r\n"; 	
				$xml.= "\t\t <row> \r\n"; 
				$xml.= "\t\t\t <string>Visits</string> \r\n"; 
				for($i=24;$i>=0;$i--){ 		
					$pv=intval( $visitData['hours'][date('Y_m_z_G',time()-($i*3600))]['visits'] );
					$xml.= "\t\t\t <number tooltip='".$pv." visits'>".$pv."</number> \r\n";  
				}
				$xml.= "\t\t </row> \r\n";				
				break;						
			*/
			case 'year': 
				$xml.= "\t\t <row> \r\n";
				$xml.= "\t\t\t <null/> \r\n"; 
				for($i=12;$i>=0;$i--){ 
					$time=mktime(1,1,1,date('n')-$i,1,date('Y'));
					$xml.= "\t\t\t <string>".date('M',$time)."</string> \r\n"; 
				}
				$xml.= "\t\t </row> \r\n"; 
				$xml.= "\t\t <row> \r\n"; 
				$xml.= "\t\t\t <string>Page Views</string> \r\n"; 
				for($i=12;$i>=0;$i--){			
					$time=mktime(1,1,1,date('n')-$i,1,date('Y'));		
					$pv=intval( $visitData['months'][date('Y_m',$time)]['pageviews'] );
					$xml.= "\t\t\t <number tooltip='".$pv." page views'>".$pv."</number> \r\n";  
				}
				$xml.= "\t\t </row> \r\n"; 	
				$xml.= "\t\t <row> \r\n"; 
				$xml.= "\t\t\t <string>Visits</string> \r\n"; 
				for($i=12;$i>=0;$i--){			
					$time=mktime(1,1,1,date('n')-$i,1,date('Y'));	
					$pv=intval( $visitData['months'][date('Y_m',$time)]['visits'] );	
					$xml.= "\t\t\t <number tooltip='".$pv." visits'>".$pv."</number> \r\n";  
				}
				$xml.= "\t\t </row> \r\n";				
				break;		
			case 'week':
			default:
				$xml.= "\t\t <row> \r\n";
				$xml.= "\t\t\t <null/> \r\n"; 
				for($i=7;$i>=0;$i--){ 
					$xml.= "\t\t\t <string>".date('D',time()-($i*3600*24))."</string> \r\n"; 
				}
				$xml.= "\t\t </row> \r\n"; 
				$xml.= "\t\t <row> \r\n"; 
				$xml.= "\t\t\t <string>Page Views</string> \r\n"; 
				for($i=7;$i>=0;$i--){				
					$pv=intval( $visitData['days'][date('Y_m_z',time()-($i*3600*24))]['pageviews'] );	
					$xml.= "\t\t\t <number tooltip='".$pv." page views'>".$pv."</number> \r\n";  
				}
				$xml.= "\t\t </row> \r\n"; 	
				$xml.= "\t\t <row> \r\n"; 
				$xml.= "\t\t\t <string>Visits</string> \r\n"; 
				for($i=7;$i>=0;$i--){					
					$pv=intval( $visitData['days'][date('Y_m_z',time()-($i*3600*24))]['visits'] );	
					$xml.= "\t\t\t <number tooltip='".$pv." visits'>".$pv."</number> \r\n";  
				}
				$xml.= "\t\t </row> \r\n";				
				break;
		} 
		
		$xml.= "\t </chart_data> \r\n";
		$xml.= "</chart> \r\n";
		
		$file_name = $this->getGraphXMLPath($timeframe);
		
		$Handle = fopen($file_name, 'w');
		fwrite($Handle, $xml);
		fclose($Handle);
	}

}


function sortByTrafficUsage($x, $y){ 
	if ( $x['usage'] == $y['usage'] ) return 0;
	else if ( $x['usage'] < $y['usage'] ) return -1;
	else return 1;
}

?>