<?php 

class SummaryParticleTrafficPanel extends ParticleTrafficPanel {

	protected $title="Summary"; 
	
	public function view(){
		
		//Visit average time, and average number of pages per visit, bounce rate
		$totalPagesViewed=0;
		$bounceVisits=0;
		$endedSessions=0;
		$totalEndedSessionsTime=0;
		$possibleReturningUsers=0;
		$returningUsers=0;
		$oldestHit=0;
		if( is_array($this->statsDisplay->visitPaths) ){
			$visitCount=count($this->statsDisplay->visitPaths);
			foreach( $this->statsDisplay->visitPaths  as $name=>$data){ 
				$pagesViewed=count($data['hitData']);  			 
				$totalPagesViewed=$totalPagesViewed+$pagesViewed;
				if($pagesViewed==1) $bounceVisits++;
				
				//calculate average time on the site 
				$lastHit=0;
				foreach($data['hitData'] as $hit){
					if( $hit['created']>$lastHit ) $lastHit=$hit['created']; 
					if($oldestHit==0 || $oldestHit>$hit['created']) $oldestHit=$hit['created']; 
				}
				
				//has page unloaded time 
				if(($data['last_page_unloaded']+1)>$lastHit){  	
					$sessionLength = $data['last_page_unloaded']-$data['created'];
					$endedSessions++;
					$totalEndedSessionsTime=$totalEndedSessionsTime+$sessionLength; 
				}elseif( $pagesViewed>1 ){
					$averagePageViewTime = ($lastHit-$data['created'])/($pagesViewed-1); 
					$sessionLength = $averagePageViewTime*$pagesViewed; 
					$endedSessions++;
					$totalEndedSessionsTime=$totalEndedSessionsTime+$sessionLength;
				}
				
				//returning users
				if( $data['returning_visit_count']>=1 ){ 
					$possibleReturningUsers++;
					if( $data['returning_visit_count']>=2 ){ 
						$returningUsers++; 
					}elseif($data['users_id']){ 
						$visitingUserInfo = ParticleTrafficDisplay::getCachedUserInfo($data['users_id']);	
						if( $visitingUserInfo->getNumLogins()>=2 ) $returningUsers++; 
					}
				} 
			}
		}
		$averagePagesPerVisit = ($visitCount) ? round($totalPagesViewed/$visitCount,1) : 0;
		$this->set('averagePagesPerVisit', $averagePagesPerVisit );
		
		$bounceRate = ($visitCount) ? round( ($bounceVisits/$visitCount)*100 ,1) : 0;
		$this->set('bounceRate', $bounceRate );
		
		$averageTimeOnSite = ($endedSessions) ? round( ($totalEndedSessionsTime/$endedSessions)) : 0;
		$this->set('averageTimeOnSite', $averageTimeOnSite );
		
		$returningUserPercent = ($possibleReturningUsers) ? round( ($returningUsers/$possibleReturningUsers)*100 ,1 ) : 0;
		$this->set('returningUserPercent', $returningUserPercent );
		
		
		//GET TOTALS 
		$totalVisits=0;
		$totalPageViews=0;
		foreach($this->statsDisplay->visitData['months'] as $dateKey=>$data){ 
			$totalVisits=intval($totalVisits)+intval($data['visits']);
			$totalPageViews=intval($totalPageViews)+intval($data['pageviews']);
		}  
		$this->set('totalVisits',$totalVisits);
		$this->set('totalPageViews',$totalPageViews);
		
		$this->set('oldestHit',$oldestHit);
		
	}



}

?>