<?php 

class UserVisitsParticleTrafficPanel extends ParticleTrafficPanel {

	protected $title="User Visits"; 
	
	
	public function action_search(){ 
	
		$statsDisplay = new ParticleTrafficDisplay();
		
		$params=array('ip'=>trim($_REQUEST['ip']));
		
		$params['page']=intval($_REQUEST['visits_pg']);
		
		$params['start_date']= (strlen($_REQUEST['start_date'])) ? strtotime($_REQUEST['start_date']) : 0;
		$params['end_date']= (strlen($_REQUEST['end_date'])) ? strtotime($_REQUEST['end_date']) : 0;
		
		if($_REQUEST['excel']){
			$params['limit_visits']=100000000;	
		}
		
		if( $_REQUEST['user_name'] ){  
			Loader::model('userinfo');
			$searchUser = UserInfo::getByUserName($_REQUEST['user_name']); 
			$params['uID']= ( is_object($searchUser) ) ? $searchUser->getUserID() : -1; 
			$params['user_name'] = $_REQUEST['user_name'];  
		}
		
		$statsDisplay->visitPaths = $statsDisplay->searchVisitPaths($params); 
		
		
		
		if($_REQUEST['excel']){ 
			
			if( !class_exists('excel_xml') ) 
				Loader::library('excel_xml','tony_stats'); 
				
			$excel = new excel_xml();  
			
			$excel->add_style('header', array( 'bold'=>1, 'size' =>'14') );  
			$excel->add_style('subheader', array( 'bold'=>1 ) );  
			
			
			
			//User Visits (without hits)
			//********************************************* 
			
			$excel->add_row( $this->encodeXMLdata(array(
				t('Visit Date'),			  
				t('IP'),
				t('Host'),
				t('Pages Viewed'), 
				t('User'),
				t('Browser'),
				t('Flash Version'),
				t('Referrer') ,
				t('Country')) 
			), 'header');
			
			
			foreach( $statsDisplay->visitPaths as $visit ){
				
				$pagesViewed=count($visit['hitData']); 
				
				$visitingUser = '';
				if( intval($visit['users_id']) ){ 
					$user = ParticleTrafficDisplay::getCachedUser($visit['users_id']);
					$visitingUser = $user->getUserName();
				} 
				
				$browser = '';
				if( strlen($visit['browser']) && strtolower($visit['browser'])!='unrecognized'){ 
					$browser = ParticleTrafficDisplay::cleanBrowserName($visit['browser']) .' '. intval($visit['browser_version']);
				} 
				
				$country=('');
				$countryData = ParticleTrafficDisplay::getCountryDataFromIP( $visit['ip'] );
				if( count($countryData) && strlen($countryData['iso_code_2']) ){ 
					$country = t($countryData['country']);
				}	
				 
				$flashVersion = ( strlen($visit['flash_version']) ) ? floatval($visit['flash_version']) : '';  
				
				$data=array();
				$data[]= date('F j, Y, g:i a',$visit['created']); 
				$data[]= $visit['ip'];
				$data[]= $visit['host_name']; 
				$data[]= $pagesViewed;
				$data[]= $visitingUser;
				$data[]= $browser; 
				$data[]= $flashVersion; 
				$data[]= $visit['referrer_url']; 
				$data[]= $country; 
				
				$excel->add_row( $this->encodeXMLdata($data) );
				
			}
			$excel->create_worksheet( t('User Visits') ); 
			
			
			//User Visits (with hits) 
			//*********************************************
			
			$excel->add_row( $this->encodeXMLdata(array(
				t('Date'),
				t('User IP / URL'),
				t('Host / Title'), 
				t('Page Count / Durations')) 
			), 'header'); 
			
			$excel->column_width=250;
			
			foreach( $statsDisplay->visitPaths as $visit ){
				
				$pagesViewed=count($visit['hitData']); 
				
				$visitingUser = '';
				if( intval($visit['users_id']) ){ 
					$user = ParticleTrafficDisplay::getCachedUser($visit['users_id']);
					$visitingUser = $user->getUserName();
				}    
				
				$data=array();
				$data[]= date('F j, Y, g:i:s a',$visit['created']); 
				$data[]= $visit['ip']; 
				$data[]= $visit['host_name']; 
				$data[]= $pagesViewed; 
				
				$excel->add_row( $this->encodeXMLdata($data), 'subheader');
				
				$lastHitTime=0;
				if( is_array($visit['hitData'])) foreach($visit['hitData'] as $hit ){
					
					if($lastHitTime==0){
						$duration= ($hit['created']>(date('U')-ParticleTrafficTracker::$visitTimeout)) ? t('Viewing') : t('Timed Out');
					}else{
						$duration= ParticleTrafficTools::timeLengthLabel($lastHitTime-$hit['created']);
					}
					
					$hitData=array();
					$hitData[]= date( 'F j, Y, g:i:s a', $hit['created'] ); 
					//$hitData[]= '<a href="'.ParticleTrafficTools::formatPageURL($hit['page_url']) .'">'.
					//		 ParticleTrafficTools::formatPageName( $hit['page_title'], $hit['page_url']).'</a>'; 
					$hitData[]= $hit['page_url'];//ParticleTrafficTools::formatPageName( $hit['page_title'], $hit['page_url']); 
					$hitData[]= $hit['page_title'];
					$hitData[]= $duration;  
					$excel->add_row( $this->encodeXMLdata($hitData) );
					$lastHitTime=$hit['created']; 
				}
			} 
			$excel->create_worksheet( t('Visit Pages') ); 		


				
			//Registered User Visits (with hits) 
			//*********************************************
			
			$excel->add_row( $this->encodeXMLdata(array(
				t('Date'),
				t('User Name / URL'),
				t('IP / Title'), 
				t('Page Count / Durations')) 
			), 'header'); 
			
			$excel->column_width=250;
			
			foreach( $statsDisplay->visitPaths as $visit ){
				
				$pagesViewed=count($visit['hitData']); 
				
				$visitingUser = '';
				if( intval($visit['users_id']) ){ 
					$user = ParticleTrafficDisplay::getCachedUser($visit['users_id']);
					$visitingUser = $user->getUserName();
				}     
				
				if(!$visitingUser) continue; 
				
				$data=array();
				$data[]= date('F j, Y, g:i:s a',$visit['created']); 
				$data[]= $visitingUser; 
				$data[]= $visit['ip']; 
				$data[]= $pagesViewed; 
				
				$excel->add_row( $this->encodeXMLdata($data), 'subheader');
				
				$lastHitTime=0;
				if( is_array($visit['hitData'])) foreach($visit['hitData'] as $hit ){
					
					if($lastHitTime==0){
						$duration= ($hit['created']>(date('U')-ParticleTrafficTracker::$visitTimeout)) ? t('Viewing') : t('Timed Out');
					}else{
						$duration= ParticleTrafficTools::timeLengthLabel($lastHitTime-$hit['created']);
					}
					
					$hitData=array();
					$hitData[]= date( 'F j, Y, g:i:s a', $hit['created'] ); 
					//$hitData[]= '<a href="'.ParticleTrafficTools::formatPageURL($hit['page_url']) .'">'.
					//		 ParticleTrafficTools::formatPageName( $hit['page_title'], $hit['page_url']).'</a>'; 
					$hitData[]= $hit['page_url'];//ParticleTrafficTools::formatPageName( $hit['page_title'], $hit['page_url']); 
					$hitData[]= $hit['page_title'];
					$hitData[]= $duration;  
					$excel->add_row( $this->encodeXMLdata($hitData) );
					$lastHitTime=$hit['created']; 
				}
			} 
			$excel->create_worksheet( t('Registered Users') );	
			
			
			
			//Print Results
			//**********************************************
			
			header("Content-Type: application/vnd.ms-excel; charset=UTF-8");
			//header( "content-type: text/xml" ); 
			header("Cache-control: private");
			header("Pragma: public");
			$date = date('Y-m-d');
			header("Content-Disposition: attachment; filename=stats_excel_export_{$date}.xml"); 
			header("Content-Title:  ". t('Statistics Export') ."- {$date}");	
			
			header("Content-Transfer-Encoding: binary");
			
			echo $excel->generate();
			
			die;
		
		}else{
		
			$json = Loader::helper('json'); 
			$jsonData = array('success'=>0 ); 
	
			ob_start();
			//$this->render();
			include($this->getPath().'visits_table.php'); 
			$html = ob_get_contents();
			ob_end_clean();
	
			$jsonData['html'] = $html;
		
			echo $json->encode( $jsonData );  
			die;
		
		}
	}
	
	
	
	protected function encodeXMLdata( $vals=array() ){
		$newArray=array();
		foreach($vals as $val) $newArray[]=htmlspecialchars($val); 
		return $vals; //$newArray;
	} 	
	

}

?>